@echo off
cd /d "%~dp0"
rem when changing below options, recommended to set the new values between = and " marks

rem target image or wim file
rem leave it blank to automatically detect wim file next to the script, or current online os
set "target="

rem updates location, remember to set the parent "Updates" directory for WHD repository
set "repo=%~dp0Updates"

rem dism.exe tool path (default is system)
set "dismroot=%windir%\system32\dism.exe"

rem Which updates to integrate?
set LDRbranch=ON
set Hotfix=ON
set WUSatisfy=ON
set WMF=OFF
set Windows10=OFF
set win10u=ON
set RSAT=OFF
set onlinelimit=75

rem set this to 1 to start the process directly once you execute the script
rem make sure you set the above options correctly first
set autostart=0

rem Optional, set mount directory for updating wim files
set mountdir=

:: ##################################################################
:: # NORMALY THERE IS NO NEED TO CHANGE ANYTHING BELOW THIS COMMENT #
:: ##################################################################

rem Technical options for updates
set gdrlist=(KB2973114,KB3023219,KB3037576,KB3074545,KB3097992,KB3122651,KB3127222,KB3135985)
set ssu1=KB3021910
set ssu2=KB3173424
set baselinelist=(KB3021910,KB2919355,KB3000850,KB2932046,KB2934018,KB2937592,KB2938439,KB2938772,KB3003057,KB3014442,KB3173424)
set hv_integ_kb=hypervintegrationservices
set hv_integ_vr=9600.18398

title Installer for Windows 8.1 Updates
%windir%\system32\reg.exe query "HKU\S-1-5-19" 1>nul 2>nul || goto :E_Admin

set "cab_dir=%temp%\cab"
if "%mountdir%"=="" set "mountdir=%cd%\mount"
if exist "%mountdir%" rmdir /s /q "%mountdir%" >nul

set wim=0
set offline=0
set online=0
set winpe=0

set _wim=0
if exist "*.wim" (for /f "delims=" %%i in ('dir /b "*.wim"') do (call set /a _wim+=1))
if "%target%"=="" if %_wim%==1 (for /f "delims=" %%i in ('dir /b /s "*.wim"') do (set "target=%%i"))
if "%target%"=="" set "target=%SystemDrive%"
if "%target:~-1%"=="\" set "target=%target:~0,-1%"
if /i "%target%"=="%SystemDrive%" goto :check

echo "%target%"| findstr /I "\.wim" >nul
if %errorlevel%==0 (
set wim=1
) else (
if exist "%target%\Windows\regedit.exe" set offline=1
)
if %offline%==0 if %wim%==0 (set "target=%SystemDrive%"&goto :check)
if %offline%==1 (
dir /b "%target%\Windows\servicing\Version\6.3.*" 1>nul 2>nul || (set "MESSAGE=Detected target offline image is not Windows 8.1"&goto :E_Target)
set "mountdir=%target%"
if exist "%target%\Windows\SysWOW64\*" (set arch=x64) else (set arch=x86)
)
if %wim%==1 (
dism /english /get-wiminfo /wimfile:"%target%" /index:1 | find /i "Version : 6.3.9600" >nul || (set "MESSAGE=Detected wim version is not Windows 8.1"&goto :E_Target)
dism /english /get-wiminfo /wimfile:"%target%" /index:1 | find /i "WindowsPE" >nul && set winpe=1
for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:"%target%" /index:1 ^| find /i "Architecture"') do set arch=%%i
for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:"%target%" ^| findstr "Index"') do set imgcount=%%i
)
if %winpe%==1 set WUSatisfy=OFF

:check
if /i "%target%"=="%SystemDrive%" (if exist "%target%\Windows\SysWOW64\*" (set arch=x64) else (set arch=x86))
for /f "tokens=6 delims=[]. " %%G in ('ver') do set winbuild=%%G
if %winbuild% geq 9600 goto :mainmenu
if /i "%dismroot%" neq "%windir%\system32\dism.exe" goto :mainmenu

:checkadk
SET regKeyPathFound=1
SET wowRegKeyPathFound=1
REG QUERY "HKLM\Software\Wow6432Node\Microsoft\Windows Kits\Installed Roots" /v KitsRoot81 1>NUL 2>NUL || SET wowRegKeyPathFound=0
REG QUERY "HKLM\Software\Microsoft\Windows Kits\Installed Roots" /v KitsRoot81 1>NUL 2>NUL || SET regKeyPathFound=0
if %wowRegKeyPathFound% EQU 0 (
  if %regKeyPathFound% EQU 0 (
    goto :mainmenu
  ) else (
    SET regKeyPath=HKLM\Software\Microsoft\Windows Kits\Installed Roots
  )
) else (
    SET regKeyPath=HKLM\Software\Wow6432Node\Microsoft\Windows Kits\Installed Roots
)
FOR /F "skip=2 tokens=2*" %%i IN ('REG QUERY "%regKeyPath%" /v KitsRoot81') DO (SET "KitsRoot=%%j")
SET "DandIRoot=%KitsRoot%Assessment and Deployment Kit\Deployment Tools"
SET "dismroot=%DandIRoot%\%PROCESSOR_ARCHITECTURE%\DISM\dism.exe"
if not exist "%dismroot%" set "dismroot=%windir%\system32\dism.exe"
goto :mainmenu

:mainboard
if %winbuild% neq 9600 (
if /i "%target%"=="%SystemDrive%" (goto :mainmenu)
)
if "%repo%"=="" (goto :mainmenu)
if "%repo:~-1%"=="\" set "repo=%repo:~0,-1%"
if exist "%repo%\Windows8.1-Update3-%arch%\Security\*" (set "repo=%repo%\Windows8.1-Update3-%arch%") else (set "repo=%repo%\Windows8.1-%arch%")
if /i "%target%"=="%SystemDrive%" (set dismtarget=/online&set "mountdir=%target%"&set online=1) else (set dismtarget=/image:"%mountdir%")
cls
setlocal enableextensions
setLocal EnableDelayedExpansion
if %online%==1 call :update
if %offline%==1 call :update
if %wim%==1 call :mount "%target%"
goto :fin

:update
if %winpe%==0 (for /f %%i in ('dir /b "%mountdir%\Windows\servicing\Editions" ^| find /i "Edition.xml"') do set CEdition=%%i)
if %winpe%==0 (set CEdition=%CEdition:~0,-11%)
set allcount=0
set GDR=0
call :baseline
call :general
call :security
call :enablenet35
call :net35
if /i %Hotfix% equ ON call :hotfix
if /i %WUSatisfy% equ ON if %winpe%==0 call :wusatisfy
if /i %WMF% equ ON call :wmf
if /i %Windows10% equ ON call :windows10
if /i %Windows10% equ ON if /i %win10u% equ ON call :win10u
if /i %RSAT% equ ON call :rsat
if %online%==1 call :online
goto :eof

:baseline
if not exist "%repo%\Baseline\*.msu" goto :eof
call :cleaner
title Processing Baseline Updates
cd Baseline\
cls
echo.
set package=KB3173424&call :baseline2
for /d %%G in %baselinelist% do (set package=%%G&call :baseline2)
goto :eof

:baseline2
if exist "%mountdir%\Windows\servicing\packages\package_for_%package%_rtm*6.3*.mum" goto :eof
if /i %package%==KB3014442 if %winpe%==1 goto :eof
if /i %package%==%ssu2% if not exist "%mountdir%\Windows\servicing\packages\package_for_KB2919355_rtm*6.3*.mum" goto :eof
if /i %package%==%ssu2% if not exist "%mountdir%\Windows\servicing\packages\package_for_KB2975061_rtm*6.3*.mum" if not exist "%mountdir%\Windows\servicing\packages\package_for_%ssu1%_rtm*6.3*.mum" goto :eof
if /i %package%==%ssu1% if exist "%mountdir%\Windows\servicing\packages\package_for_%ssu2%_rtm*6.3*.mum" goto :eof
if %online%==1 if /i %package%==%ssu1% if exist "%windir%\winsxs\pending.xml" (goto :stacklimit)
if %online%==1 if /i %package%==%ssu2% if exist "%windir%\winsxs\pending.xml" (goto :stacklimit)
echo.
echo ============================================================
echo Installing %package%
echo ============================================================
if /i %package%==KB2938772 (
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:RTM\Windows8.1-%package%-%arch%.cab
goto :eof
)
for /f "delims=" %%i in ('dir /b /s "*%package%-%arch%.msu"') do expand.exe -f:*Windows*.cab "%%i" "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%\Windows8.1-%package%-%arch%.cab"
if %online%==1 if /i %package%==KB2919355 (goto :cumulativelimit)
if %online%==1 if /i %package%==KB3000850 (goto :cumulativelimit)
goto :eof

:general
if not exist "%repo%\General\*.msu" goto :eof
call :cleaner
title Processing General Updates
cd General\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=General Updates
goto :listdone

:security
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Security\*.msu" goto :eof
call :cleaner
title Processing Security Updates
cd Security\
if /i "%CEdition%" EQU "ProfessionalWMC" if exist "ProWMC\*%arch%*.msu" (expand.exe -f:*Windows*.cab ProWMC\*%arch%*.msu .\ >nul)
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
if exist "%repo%\Security\*.cab" (del "%repo%\Security\*.cab" >nul)
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Security Updates
goto :listdone

:net35
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%mountdir%\Windows\Microsoft.NET\Framework\v2.0.50727\ngen.exe" goto :eof
if not exist "%repo%\Additional\NET35\*.msu" goto :eof
call :cleaner
title Processing .NET 3.5 Updates
cd Additional\NET35\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=.NET 3.5 Updates
goto :listdone

:hotfix
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Hotfix\*.msu" goto :eof
call :cleaner
title Processing Hotfixes
cd Hotfix\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Hotfixes
goto :listdone

:wusatisfy
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\WU.Satisfy\*.msu" goto :eof
call :cleaner
title Processing WU Satisfy Updates
md "%cab_dir%\WU"
if /i %LDRbranch% equ ON if exist "%mountdir%\Windows\Microsoft.NET\Framework\v2.0.50727\ngen.exe" (for /d %%G in %gdrlist% do (copy Additional\NET35\*%%G*%arch%.msu "%cab_dir%\WU" 1>nul 2>nul))
cd Additional\WU.Satisfy\
for /f "delims=" %%a in ('"dir /b /s *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\WU" >nul)
for /f "delims=" %%a in ('"dir /b /s *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\WU" >nul)
cd /d "%cab_dir%\WU"
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set GDR=1
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set GDR=0
set cat=WU Satisfy Updates
goto :listdone

:windows10
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\Windows10\*.msu" goto :eof
call :cleaner
title Processing Windows10 related Updates
cd Additional\Windows10\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Windows10 Updates
goto :listdone

:wmf
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\WMF\*.msu" goto :eof
if not exist "%mountdir%\Windows\Microsoft.NET\Framework\v4.0.30319\ngen.exe" goto :eof
if %winpe%==1 goto :eof
call :cleaner
title Processing WMF package
cd Additional\WMF\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=WMF Updates
goto :listdone

:rsat
if %online%==1 if %allcount% geq %onlinelimit% (goto :countlimit)
call :cleaner
title Processing RSAT Updates
if exist "%mountdir%\Windows\servicing\packages\*RemoteServerAdministrationTools*.mum" (
call :rsatu
goto :eof
)
if not exist "%repo%\Extra\RSAT\*.msu" goto :eof
cd Extra\RSAT\
echo.
echo __________________________________________________________________
echo.
echo Installing RSAT package
echo.
for /f %%i in ('dir /b *%arch%.msu') do expand.exe -f:*Windows*.cab %%i "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%"
call :rsatu
goto :eof

:rsatu
if not exist "%repo%\Extra\RSAT\Updates\*.msu" goto :eof
call :cleaner
cd Extra\RSAT\Updates\
call :counter
if %_sum% equ 0 goto :eof
cls
echo.
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=100&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=RSAT Updates
goto :listdone

:online
if not exist "%repo%\Additional\Do.Not.Integrate\*.msu" goto :eof
call :cleaner
title Processing Exclusive online updates
cd Additional\Do.Not.Integrate\
for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :online2)
goto :eof

:online2
for /f "tokens=2 delims=-" %%V in ('dir /b %package%') do set kb=%%V
if exist "%windir%\servicing\packages\package_for_%kb%_rtm*6.3*.mum" goto :eof
cls
echo.
echo Checking %kb% applicability
set oempreload=
if /i %kb%==KB3021128 (
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKLM\HARDWARE\DESCRIPTION\System\BIOS" /v BaseBoardProduct ^| find /i "UB-15MS10"') do set oempreload=%%i
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKLM\HARDWARE\DESCRIPTION\System\BIOS" /v BaseBoardProduct ^| find /i "NS-15MS08"') do set oempreload=%%i
)
if /i %kb%==KB3021128 if not defined oempreload (set /a _sum-=1&set /a _msu-=1&goto :eof)
set mavut=
if /i %kb%==KB3083669 (
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKLM\SOFTWARE\McAfee\MSC\AppInfo\Substitute" /v version2 ^| find /i "13.0"') do set mavut=%%i
for /f "tokens=3" %%i in ('%windir%\system32\reg.exe query "HKLM\SOFTWARE\McAfee\MSC\AppInfo\Substitute" /v version2 ^| find /i "13.6"') do set mavut=%%i
)
if /i %kb%==KB3083669 if not defined mavut (set /a _sum-=1&set /a _msu-=1&goto :eof)
echo.
echo __________________________________________________________________
echo.
echo Installing %kb%
%package% /quiet /norestart
goto :eof

:enablenet35
if exist "%mountdir%\Windows\Microsoft.NET\Framework\v2.0.50727\ngen.exe" goto :eof
if %winpe%==1 goto :eof
call :cleaner
title Processing .NET 3.5 Feature
for %%b in (D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z) do if exist "%%b:\sources\sxs\msil_microsoft.build.engine*3.5.9600.16384*" set "_net35=%%b:\sources\sxs"
for /f "delims=" %%i in ('dir /b /s "%target%"') do if exist "%%~dpisxs\msil_microsoft.build.engine*3.5.9600.16384*" set "_net35=%%~dpisxs"
if not defined _net35 goto :eof
cls
echo.
echo Enabling .NET Framework 3.5 feature
echo __________________________________________________________________
echo.
"%dismroot%" %dismtarget% /NoRestart /Enable-Feature /Featurename:NetFx3 /Source:"%_net35%"
goto :eof

rem ##################################################################

:cab
if %online%==1 if %count% equ %onlinelimit% goto :eof
cls
for /f "tokens=2 delims=-" %%V in ('dir /b %package%') do set kb=%%V
if /i %kb%==KB917607 (if exist "%mountdir%\Windows\WinSxS\Manifests\*microsoft-windows-winhstb*6.3.9600.20470*.manifest" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2899189 (if exist "%mountdir%\Windows\servicing\packages\*CameraCodec*6.3.9600.16453.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB3134758 (if exist "%mountdir%\Windows\servicing\packages\*WinMan-WinIP*7.2.9600.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB3140185 (if not exist "%mountdir%\Windows\servicing\packages\Microsoft-Windows-Anytime-Upgrade-Package*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2894852 (if not exist "%mountdir%\Windows\Microsoft.NET\Framework\v2.0.50727\ngen.exe" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2973201 (if /i "%CEdition%" NEQ "ProfessionalWMC" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2978742 (if /i "%CEdition%" NEQ "ProfessionalWMC" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB3172729 (if /i "%dismroot%" NEQ "%windir%\system32\dism.exe" set /a _sum-=1&set /a _msu-=1&goto :eof)
set inver=
if /i %kb%==%hv_integ_kb% if exist "%mountdir%\Windows\servicing\packages\*Hyper-V-Integration-Services*.mum" (
echo.
echo Checking installed %kb% version
for /f "tokens=6,7 delims=~." %%i in ('dir /b /od "%mountdir%\Windows\servicing\packages\*Hyper-V-Integration-Services*.mum"') do call set inver=%%i%%j
)
if defined inver (if !inver! GEQ !hv_integ_vr! (set /a _sum-=1&set /a _cab-=1&goto :eof))
set inver=
set "mumcheck=package_for_%kb%_rtm*6.3*.mum"
if %GDR% equ 1 set "mumcheck=package_for_%kb%_rtm~*6.3*.mum"
if exist "%mountdir%\Windows\servicing\packages\%mumcheck%" (
echo.
echo Checking installed %kb% version
for /f "tokens=6,7 delims=~." %%i in ('dir /b /od "%mountdir%\Windows\servicing\packages\%mumcheck%"') do call set inver=%%i%%j
mkdir "%cab_dir%\check"
if %msu% equ 1 (expand.exe -f:*Windows*.cab %package% "%cab_dir%\check" >nul) else (copy %package% "%cab_dir%\check" >nul)
expand.exe -f:package_for_%kb%_rtm~*.mum "%cab_dir%\check\*.cab" "%cab_dir%\check" >nul
for /f "tokens=6,7 delims=~." %%i in ('dir /b "%cab_dir%\check\package_for_%kb%_rtm*6.3*.mum"') do call set kbver=%%i%%j
rd /s /q "%cab_dir%\check"
)
if defined inver (if !inver! GEQ !kbver! (set /a _sum-=1&set /a _msu-=1&goto :eof))
set /a count+=1
echo.
if %msu% equ 1 (echo Extracting .cab files from .msu files) else (echo Copying .cab files to temp folder)
echo __________________________________________________________________
echo.
echo.
if %msu% equ 1 (echo %count% of %_msu%: %package%) else (echo %count% of %_cab%: %package%)
if %msu% equ 1 (expand.exe -f:*Windows*.cab %package% "%cab_dir%" >nul) else (copy %package% "%cab_dir%" >nul)
goto :eof

:mum
if %listc% geq %ac% (set /a AC+=100&set /a list+=1&set ldr%list%=%ldr%&set ldr=)
set package=%1
set dest=%~n1
md "%dest%"
expand.exe -f:*.mum "%package%" "%dest%" 1>nul 2>nul
if %winpe%==1 (
findstr /i /m "WinPE" "%dest%\*.mum" 1>nul 2>nul || (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-HTA-Package" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-MDAC-Package-com" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-MDAC-Package-enduser" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-NetFx-Package" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-PowerShell-Package" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
findstr /i /m "WinPE-RNDIS-Package" "%dest%\update.mum" 1>nul 2>nul && (set /a _sum-=1&goto :eof)
)
del /f /q "%dest%\update.mum" 1>nul 2>nul
set /a count+=1
set /a allcount+=1
set /a listc+=1
cls
echo.
echo Extracting files from update cabinets (.cab)
echo *** This will require some disk space, please be patient ***
echo __________________________________________________________________
echo.
echo.
echo %count% of %_sum%: %package%
expand.exe -f:* "%package%" "%dest%" 1>nul 2>nul || (set "ldr=!ldr! /packagepath:%package%"&goto :eof)
if /i %LDRbranch% neq ON (set "ldr=!ldr! /packagepath:%dest%\update.mum"&goto :eof)
if %GDR% equ 1 (set "ldr=!ldr! /packagepath:%dest%\update.mum"&goto :eof)
if exist "%dest%\update-bf.mum" (set "ldr=!ldr! /packagepath:%dest%\update-bf.mum") else (set "ldr=!ldr! /packagepath:%dest%\update.mum")
if not exist "%dest%\*cablist.ini" goto :eof
expand.exe -f:* "%dest%\*.cab" "%dest%" 1>nul 2>nul || (set "ldr=!ldr! /packagepath:%package%")
del /f /q "%dest%\*cablist.ini" 1>nul 2>nul
del /f /q "%dest%\*.cab" 1>nul 2>nul
goto :eof

:listdone
if %listc% lss %ac% (set ldr%list%=%ldr%)
set lc=1
cls
echo.
echo Now installing Updates...
echo __________________________________________________________________
echo.

:PP
if %lc% gtr %list% goto :eof
call set ldr=%%ldr%lc%%%
set ldr%lc%=
Title %listc% %cat%, session %lc% of %list%
"%dismroot%" %dismtarget% /NoRestart /Add-Package %ldr%
set /a lc+=1
goto :PP

:cleaner
cd /d "%repo%"
if exist "%cab_dir%" (echo.&echo Please wait whilst temporary install files are removed...&rd /s /q "%cab_dir%"&echo.)
if not exist "%cab_dir%" md "%cab_dir%"
goto :eof

:counter
set _msu=0
set _cab=0
set _sum=0
if exist "*%arch%*.msu" (for /f %%a in ('dir /b *%arch%*.msu') do (call set /a _msu+=1))
if exist "*%arch%*.cab" (for /f %%a in ('dir /b *%arch%*.cab') do (call set /a _cab+=1))
set /a _sum=%_msu%+%_cab% >nul
goto :eof

rem ##################################################################

:win10u
title Processing Windows10/Telemetry Block tweaks
cls
set _schtasks=%windir%\system32\schtasks.exe
if %online%==1 (set ksub1=SOFTWARE&set ksub2=SYSTEM) else (set ksub1=OFFSOFT&set ksub2=OFFSYST)
if %online%==0 (
%_reg% load HKLM\%ksub1% "%mountdir%\Windows\System32\config\SOFTWARE" >nul
%_reg% load HKLM\%ksub2% "%mountdir%\Windows\System32\config\SYSTEM" >nul
)
%_reg% add HKLM\%ksub2%\ControlSet001\Services\DiagTrack /v Start /t REG_DWORD /d 4 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Policies\Microsoft\Windows\Gwx /v DisableGwx /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Policies\Microsoft\Windows\WindowsUpdate /v DisableOSUpgrade /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade /v AllowOSUpgrade /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade /v ReservationsAllowed /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /f /v IncludeRecommendedUpdates /t REG_DWORD /d 0 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Appraiser" /v HaveUploadedForTarget /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\AIT" /v AITEnable /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v DontRetryOnError /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v IsCensusDisabled /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v TaskEnableRun /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags" /v UpgradeEligible /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v OSUpgradePendingReboot /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\RebootRequired" /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\Volatile" /v OSUpgradeStartTime /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v AutoRebootDelay /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v KickoffDownload /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v KickoffUpgrade /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade\State" /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Reporting\EventCache.v2\Legacy\9482f4b4-e343-43b6-b170-9a65bc822c77" /f 1>nul 2>nul
if not defined online (
%_reg% unload HKLM\%ksub1% >nul
%_reg% unload HKLM\%ksub2% >nul
goto :eof
)
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\Microsoft Compatibility Appraiser" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\ProgramDataUpdater" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\AitAgent" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\launchtrayprocess" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfig" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfigandcontent" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxcontent" /DISABLE >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\Microsoft Compatibility Appraiser" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\ProgramDataUpdater" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\AitAgent" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\launchtrayprocess" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfig" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfigandcontent" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxcontent" >nul 2>&1
(echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\refreshgwxconfig-B" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-URT" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\MachineUnlock-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfIdle-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfSleep-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeReminderTime" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeTime" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Telemetry-4xd" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Time-5d" /DISABLE
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\refreshgwxconfig-B"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-URT"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\MachineUnlock-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfIdle-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfSleep-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeReminderTime"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeTime"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Telemetry-4xd"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Time-5d")>%windir%\Tasks.cmd
%_schtasks% /Create /F /RU "SYSTEM" /RL HIGHEST /SC HOURLY /TN Tasks /TR "cmd /c %windir%\Tasks.cmd" >nul 2>&1
%_schtasks% /Run /I /TN Tasks >nul 2>&1
TIMEOUT /T 5 >nul 2>&1
%_schtasks% /Delete /F /TN Tasks >nul 2>&1
del /f /q %windir%\Tasks.cmd >nul 2>&1
%windir%\system32\sc.exe config DiagTrack start= disabled 1>nul 2>nul
%windir%\system32\sc.exe stop DiagTrack 1>nul 2>nul
goto :eof

:stacklimit
title Installer for Windows Updates
cls
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo Servicing stack %package% installation require no pending update operation.
echo ____________________________________________________________________________
echo.
echo please restart the system
echo after the reboot, run the script to install %package% and other updates.
echo.
echo.
echo Press any key to Exit
pause >nul
exit

:cumulativelimit
title Installer for Windows Updates
cls
call :cleaner
cls
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo Due the cumulative nature, %package% installation require a system restart.
echo ____________________________________________________________________________
echo.
echo please restart the system
echo after the reboot, rerun the script to install other updates.
echo.
echo.
echo Press any key to Exit
pause >nul
exit

:countlimit
title Installer for Windows Updates
cls
call :cleaner
cls
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo %onlinelimit% or more updates had been installed
echo installing further more will make the process extremely slow.
echo ____________________________________________________________________________
echo.
echo please restart the system now
echo after the reboot, rerun the script to install other updates.
echo.
echo.
echo Press any key to Exit
pause >nul
exit

rem ##################################################################

:mainmenu
if %autostart%==1 goto :mainboard
set _pp=
cls
echo ==================================================================
echo.
if /i "%target%"=="%SystemDrive%" (echo 1. Target   ^(%arch%^) : Current Online OS) else (echo 1. Target   ^(%arch%^) : "%target%")
echo.
echo 2. WHD Repository : "%repo%"
echo.
echo 3. LDR branch     : %LDRbranch%
echo 4. Hotfixes       : %Hotfix%
echo 5. WU Satisfy     : %WUSatisfy%
if /i %Windows10% equ OFF (echo 6. Windows10      : %Windows10%) else (echo 6. Windows10      : %Windows10%        / B. Block Windows10/Telemetry: %win10u%)
echo 7. WMF            : %WMF%
echo 8. RSAT           : %RSAT%
if /i "%target%" neq "%SystemDrive%" (echo.&echo D. DISM : "%dismroot%")
if /i "%target%" equ "%SystemDrive%" (echo.&echo 9. Online installation limit: %onlinelimit% updates)
echo.
echo ==================================================================
echo 0. Start the process
echo ==================================================================
echo.
choice /c 1234567890DBX /n /m "Change a menu option, press 0 to start, or X to exit: "
if errorlevel 13 goto :eof
if errorlevel 12 (if /i %win10u% equ ON (set win10u=OFF) else (set win10u=ON))&goto :mainmenu
if errorlevel 11 goto :dismmenu
if errorlevel 10 goto :mainboard
if errorlevel 9 goto :countmenu
if errorlevel 8 (if /i %RSAT% equ ON (set RSAT=OFF) else (set RSAT=ON))&goto :mainmenu
if errorlevel 7 (if /i %WMF% equ ON (set WMF=OFF) else (set WMF=ON))&goto :mainmenu
if errorlevel 6 (if /i %Windows10% equ ON (set Windows10=OFF) else (set Windows10=ON))&goto :mainmenu
if errorlevel 5 (if /i %WUSatisfy% equ ON (set WUSatisfy=OFF) else (set WUSatisfy=ON))&goto :mainmenu
if errorlevel 4 (if /i %Hotfix% equ ON (set Hotfix=OFF) else (set Hotfix=ON))&goto :mainmenu
if errorlevel 3 (if /i %LDRbranch% equ ON (set LDRbranch=OFF) else (set LDRbranch=ON))&goto :mainmenu
if errorlevel 2 goto :repomenu
if errorlevel 1 goto :targetmenu
goto :mainmenu

:targetmenu
cls
echo ============================================================
echo Enter the path for one of:
echo - WIM file
echo - Mounted directory, offline image drive letter
echo.
echo or just press 'Enter' to return to options menu
echo ============================================================
echo.
set /p _pp=
if "%_pp%"=="" goto :mainmenu
if "%_pp:~-1%"=="\" set "_pp=%_pp:~0,-1%"
set "target=%_pp%"
if /i "%target%"=="%SystemDrive%" goto :mainmenu
echo %target%| findstr /E /I "\.wim" >nul
if %errorlevel%==0 (
set wim=1
) else (
if exist "%target%\Windows\regedit.exe" set offline=1
)
if %offline%==0 if %wim%==0 (set "MESSAGE=Specified target is not valid"&goto :E_Target)
if %offline%==1 (
dir /b "%target%\Windows\servicing\Version\6.3.*" 1>nul 2>nul || (set "MESSAGE=Detected target offline image is not Windows 8.1"&goto :E_Target)
set "mountdir=%target%"
if exist "%target%\Windows\SysWOW64\*" (set arch=x64) else (set arch=x86)
)
if %wim%==1 (
dism /english /get-wiminfo /wimfile:"%target%" /index:1 | find /i "Version : 6.3.9600" >nul || (set "MESSAGE=Detected wim file version is not Windows 8.1"&goto :E_Target)
for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:"%target%" /index:1 ^| find /i "Architecture"') do set arch=%%i
for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:"%target%" ^| findstr "Index"') do set imgcount=%%i
)
goto :mainmenu

:repomenu
cls
echo ============================================================
echo Enter the location of WHD parent "Updates" folder
echo.
echo or just press 'Enter' to return to options menu
echo ============================================================
echo.
set /p _pp=
if "%_pp%"=="" goto :mainmenu
if "%_pp:~-1%"=="\" set "_pp=%_pp:~0,-1%"
set "repo=%_pp%"
if not exist "%repo%\*" (goto :E_Repo)
goto :mainmenu

:countmenu
cls
echo ============================================================
echo Enter the updates count limit for online installation
echo.
echo or just press 'Enter' to return to options menu
echo ============================================================
echo.
set /p _pp=
if "%_pp%"=="" goto :mainmenu
set onlinelimit=%_pp%
goto :mainmenu

:dismmenu
cls
echo ============================================================
echo Enter the path of Custom dism.exe
echo.
echo or just press 'Enter' to return to options menu
echo ============================================================
echo.
set /p _pp=
if "%_pp%"=="" goto :mainmenu
set "dismroot=%_pp%"
if not exist "%dismroot%" (
echo not found: "%dismroot%"
pause
set "dismroot=%windir%\system32\dism.exe"
)
"%dismroot%" /? | findstr /I /B "Version" >dismver.txt
for /f "tokens=4 delims=:. " %%i in (dismver.txt) do set _ver=%%i
del /f /q dismver.txt
if %_ver% lss 9600 (
echo.
echo ERROR: DISM version is less than 6.3.9600
pause
set "dismroot=%windir%\system32\dism.exe"
)
goto :mainmenu

:mount
if not exist "%mountdir%" mkdir "%mountdir%"
for /L %%i in (1, 1, %imgcount%) do (
echo.
echo ============================================================
echo Mounting %~nx1 - index %%i/%imgcount%
echo ============================================================
"%dismroot%" /Mount-Wim /Wimfile:%1 /Index:%%i /MountDir:"%mountdir%"
if errorlevel 1 goto :E_MOUNT
call :update
if %winpe%==1 (
echo.
echo ============================================================
echo Resetting the image base
echo ============================================================
"%dismroot%" /Image:"%mountdir%" /Cleanup-Image /StartComponentCleanup /ResetBase
) else if not exist "%mountdir%\Windows\WinSxS\pending.xml" (
echo.
echo ============================================================
echo Resetting the image base
echo ============================================================
"%dismroot%" /Image:"%mountdir%" /Cleanup-Image /StartComponentCleanup /ResetBase
)
if exist "%mountdir%\Windows\WinSxS\ManifestCache\*.bin" (
takeown /f "%mountdir%\Windows\WinSxS\ManifestCache\*.bin" /A >nul 2>&1
icacls "%mountdir%\Windows\WinSxS\ManifestCache\*.bin" /grant *S-1-5-32-544:F >nul 2>&1
del /f /q "%mountdir%\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
)
if exist "%mountdir%\Windows\WinSxS\Temp\PendingDeletes\*" (
takeown /f "%mountdir%\Windows\WinSxS\Temp\PendingDeletes\*" /A >nul 2>&1
icacls "%mountdir%\Windows\WinSxS\Temp\PendingDeletes\*" /grant *S-1-5-32-544:F >nul 2>&1
del /f /q "%mountdir%\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
)
if exist "%mountdir%\Windows\WinSxS\Temp\TransformerRollbackData\*" (
takeown /f "%mountdir%\Windows\WinSxS\Temp\TransformerRollbackData\*" /R /A >nul 2>&1
icacls "%mountdir%\Windows\WinSxS\Temp\TransformerRollbackData\*" /grant *S-1-5-32-544:F /T >nul 2>&1
del /s /f /q "%mountdir%\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
)
if exist "%mountdir%\Windows\inf\*.log" (
del /f /q "%mountdir%\Windows\inf\*.log" >nul 2>&1
)
if exist "%mountdir%\Windows\System32\Recovery\winre.wim" attrib -S -H -I "%mountdir%\Windows\System32\Recovery\winre.wim" 1>nul 2>nul
echo.
echo ============================================================
echo Unmounting %~nx1 - index %%i/%imgcount%
echo ============================================================
"%dismroot%" /Unmount-Wim /MountDir:"%mountdir%" /Commit
if errorlevel 1 goto :E_MOUNT
)
cd /d "%~dp0"
echo.
echo ============================================================
echo Rebuilding %~nx1
echo ============================================================
for /L %%i in (1, 1, %imgcount%) do (
"%dismroot%" /Export-Image /SourceImageFile:%1 /SourceIndex:%%i /DestinationImageFile:"%~dp0temp.wim"
)
move /y "%~dp0temp.wim" %1 >nul
goto :eof

:E_Target
echo.
echo ============================================================
echo ERROR: %MESSAGE%
echo ============================================================
echo.
echo Press any key to continue.
pause >nul
set target=%SystemDrive%
goto :mainmenu

:E_Repo
echo.
echo ============================================================
echo ERROR: Specified location is not valid
echo ============================================================
echo.
echo Press any key to continue.
pause >nul
set "repo=%~dp0Updates"
goto :mainmenu

:E_MOUNT
echo.
echo ============================================================
echo ERROR: Could not mount or unmount WIM image
echo ============================================================
echo.
echo Press any key to exit.
pause >nul
exit

:E_Admin
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo This script must be run with administrator privileges
echo To do so, right click on it and select 'Run as administrator'
echo.
echo.
echo Press any key to exit.
pause >nul
goto :eof

:fin
title Installer for Windows 8.1 Updates
cls
echo.
cd /d "%~dp0"
echo.
echo.
if exist "%cab_dir%" (echo Please wait whilst temporary install files are removed...&rd /s /q "%cab_dir%"&echo.)
echo ############################################################################
echo.
echo    Finished
echo.
if %online%==1 if exist "%windir%\winsxs\pending.xml" (echo.&echo System restart is required.)
echo.
echo Press any key to exit.
pause >nul
goto :eof
